﻿;/////////////////////////////////////////////////////////////////////////////////
;Demo of the OOP class for implementing a simple integer stack.
;nxSoftware.

;Demonstrates some of the methods exposed by the 'StackObject' class.
;/////////////////////////////////////////////////////////////////////////////////

XIncludeFile "integerStackClass.pbi"


;Create a stack object with room for 10 elements.
  MyStackObject.IntegerStackObject
  MyStackObject = NewIntegerStack(10)


If MyStackObject ;Always check that the object was created successfully.
;Fill the stack with values 1,2,3,...10.
  For i = 1 To 10
    MyStackObject\Push(i)
  Next 

;There should be 10 elements currently pushed on the stack.
  Debug "There are " + Str(MyStackObject\NumberOfElementsPushed()) + " elements pushed on the stack."

;Have a look. Should debug 10,9,8,...1.
  count = MyStackObject\NumberOfElementsPushed()
  For i = 1 To count
    Debug  "Popping item " + Str(i) + " -> " + Str(MyStackObject\Pop())
  Next 
  
;There should be no elements currently pushed on the stack.
  Debug "There are " + Str(MyStackObject\NumberOfElementsPushed()) + " elements pushed on the stack."

;Destroy the stack once it is no longer required.
  MyStackObject\Destroy()

Else
  MessageRequester("Error :", "There was a memory allocation problem creating the stack object.")
EndIf
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; EnableXP